if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
   return
end

------------------------------------------------------------------------
local BG_Tex = "Interface\\AddOns\\ThreeRuneBars\\runes.tga";

local BarPos = {
	["Bar1"] = { ["x"] = 2, ["y"] = -2 },
	["Bar2"] = { ["x"] = 2+(2*48 + 8), ["y"] = -2 },
	["Bar3"] = { ["x"] = 2+((4*48) + 16), ["y"] = -2 },
};
------------------------------------------------------------------------

TRB_Runes = TRB_Module:create("Runes");

function TRB_Runes:OnDisable()
	self.frame:SetScript("OnUpdate", nil);
	self.frame:SetScript("OnEvent", nil);
end

function TRB_Runes:OnLoadPosition()
	TRB_Runes:UpdateBarPositions();
end

function TRB_Runes:UpdateBarPositions()
--	if( not (TRB_Config.Runes.Order and TRB_Config.Runes.Order.Blood and TRB_Config.Runes.Unholy and TRB_Config.Runes.Frost) ) then
		--self:OnLoadConfig(true);
--	end
	
	--self:Print("UpdateBarPositions()");
	--self:Print("BarPos: Blood => "..TRB_Config.Runes.Order["Blood"]);
	--self:Print("BarPos: Unholy => "..TRB_Config.Runes.Order["Unholy"]);
	--self:Print("BarPos: Frost => "..TRB_Config.Runes.Order["Frost"]);

	-- Blood
	self.Bars[1]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", BarPos[TRB_Config.Runes.Order["Blood"]]["x"], BarPos[TRB_Config.Runes.Order["Blood"]]["y"]);
	
	-- Unholy
	self.Bars[3]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", BarPos[TRB_Config.Runes.Order["Unholy"]]["x"], BarPos[TRB_Config.Runes.Order["Unholy"]]["y"]);
	
	-- Frost
	self.Bars[5]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", BarPos[TRB_Config.Runes.Order["Frost"]]["x"], BarPos[TRB_Config.Runes.Order["Frost"]]["y"]);
end

function TRB_Runes:OnEnable()

	--DEFAULT_CHAT_FRAME:AddMessage("UT: module Runes Loaded");
	
	if( not self.frame ) then
		local f = CreateFrame("frame", nil, UIParent);
		
		-- Set position
		f:SetWidth(48*6+22)
		f:SetHeight(8+4)
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 0 );
		f:SetFrameStrata("HIGH");
		f.owner = self;
		self.frame = f;
		f:Show();
		
		-- Background
		local bg = f:CreateTexture(nil, "BACKGROUND");
		bg:SetWidth(512);
		bg:SetHeight(512);
		bg:SetPoint("CENTER", f, "CENTER", 0, 0);
		bg:SetTexture(BG_Tex);
		self.bg = bg;
		
		self:CreateMoveFrame();
	end
	
	if( not self.Bars ) then
		
		self.Bars = {};
		self.needUpdate = { [1] = false, [2] = false, [3] = false, [4] = false, [5] = false, [6] = false };

		-- Blood
		self.Bars[1] = self:CreateBar("TRB_blood1", self.frame);
		self.Bars[1]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", BarPos["Bar1"]["x"], BarPos["Bar1"]["y"]);
		self.Bars[2] = self:CreateBar("TRB_blood2", self.frame);
		self.Bars[2]:SetPoint("TOPLEFT", self.Bars[1], "TOPRIGHT", 2, 0);
		self:UpdateColor(1, 1);
		self:UpdateColor(2, 1);
		
		-- Unholy
		self.Bars[3] = self:CreateBar("TRB_unholy1", self.frame);
		self.Bars[3]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", BarPos["Bar2"]["x"], BarPos["Bar2"]["y"]);
		self.Bars[4] = self:CreateBar("TRB_unholy2", self.frame);
		self.Bars[4]:SetPoint("TOPLEFT", self.Bars[3], "TOPRIGHT", 2, 0);
		self:UpdateColor(3, 2);
		self:UpdateColor(4, 2);

		-- Frost
		self.Bars[5] = self:CreateBar("TRB_frost1", self.frame);
		self.Bars[5]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", BarPos["Bar3"]["x"], BarPos["Bar3"]["y"]);
		self.Bars[6] = self:CreateBar("TRB_frost2", self.frame);
		self.Bars[6]:SetPoint("TOPLEFT", self.Bars[5], "TOPRIGHT", 2, 0);
		self:UpdateColor(5, 3);
		self:UpdateColor(6, 3);
		
		--self:UpdateBarPositions();
	end
	
	--
	--  EVENTS
	--	
	-- Runes
	self.frame:RegisterEvent("RUNE_POWER_UPDATE")
	self.frame:RegisterEvent("RUNE_TYPE_UPDATE")

	self.last = 0;
	self.frame:SetScript("OnEvent", function(frame, event, ...) frame.owner[event](frame.owner, ...); end );
	self.frame:SetScript("OnUpdate", function(frame, elapsed) frame.owner:OnUpdate(elapsed); end );
end

function TRB_Runes:UpdateColor(r, t, faded)
	if( t == nil) then t=GetRuneType(r); end

	local a = 1;
	if( faded ) then
		a = 0.8;
	end
	self.Bars[r]:SetStatusBarColor(TRB_Config.Runes["Colors"][t][1], TRB_Config.Runes["Colors"][t][2], TRB_Config.Runes["Colors"][t][3], a);
	local bg = self.Bars[r].bg;
	
	bg:SetTexture(TRB_Config.Runes.Colors[t][1], TRB_Config.Runes.Colors[t][2], TRB_Config.Runes.Colors[t][3], 0.35);
	
end

function TRB_Runes:UpdateText( bar, value, duration )

	if( TRB_Config.Runes.noText ) then
		self.Bars[bar].text:SetText("");
		return;
	end

--	self:Print("Bar "..bar.." value "..value.." duration "..duration);

	if( value > 0 and value < duration) then
		if( value < 2 ) then
			self.Bars[bar].text:SetText( format("%.1f", value) );
		else
			self.Bars[bar].text:SetText( format("%.0f", value) );
		end
	else
		self.Bars[bar].text:SetText("");
	end
end

function TRB_Runes:Updatebar( rune1, rune2 )
	local s1, d1, r1 = GetRuneCooldown(rune1);
	local s2, d2, r2 = GetRuneCooldown(rune2);
	local rt1 = GetRuneType(rune1);
	local rt2 = GetRuneType(rune2);
	
	local val1 = GetTime() - s1;
	local val2 = GetTime() - s2;
	if( r1 or val1 > d1) then
		val1 = d1;
	end
	if( r2 or val2 > d2) then
		val2 = d2;
	end
	if( val1 < 0 ) then val1 = 0 end
	if( val2 < 0 ) then val2 = 0 end
	
--	val1 = (val1 / d1) * 100;
--	val2 = (val2 / d2) * 100;
	
	if( val1 < val2 ) then
		self.Bars[rune1]:SetValue((val2 / d2) * 100);
		self.Bars[rune2]:SetValue((val1 / d1) * 100);
		
		self:UpdateText(rune1, d2-val2, d2);
		self:UpdateText(rune2, d1-val1, d1);
		
		self:UpdateColor(rune1, rt2, (val2 < 99));
		self:UpdateColor(rune2, rt1, (val1 < 99));
	else
		self.Bars[rune1]:SetValue((val1 / d1) * 100);
		self.Bars[rune2]:SetValue((val2 / d2) * 100);
		
		self:UpdateText(rune1, d1-val1, d1);
		self:UpdateText(rune2, d2-val2, d2);
		
		self:UpdateColor(rune1, rt1, (val1 < 99));
		self:UpdateColor(rune2, rt2, (val2 < 99));
	end
end

-- Runes EVENTS
function TRB_Runes:RUNE_POWER_UPDATE(rune, useable)
	if( not useable ) then
		self.needUpdate[rune] = true;
	end
end

function TRB_Runes:RUNE_TYPE_UPDATE(rune)
	self:UpdateColor(rune);
end

-- OnUpdate
function TRB_Runes:OnUpdate(elapsed)
	self.last = self.last + elapsed;
	
	if( self.last > 0.01 ) then
		if( self.needUpdate[1] or self.needUpdate[2] ) then
			self:Updatebar( 1, 2); -- Blood
		end
		
		if( self.needUpdate[3] or self.needUpdate[4] ) then
			self:Updatebar( 3, 4); -- Unholy
		end
		
		if( self.needUpdate[5] or self.needUpdate[6] ) then
			self:Updatebar( 5, 6); -- Frost
		end
		
		self.last = 0;
	end
end

-- Register Rune module
ThreeRuneBars:RegisterModule(TRB_Runes.name, TRB_Runes);


















---------------- Config
local DD_items = { "Blood", "Unholy", "Frost" };

function TRB_Runes:OnLoadConfig(forceReset)

	if( not TRB_Config.Runes.Order or forceReset) then
		--self:Print("OnLoadConfig()");
		TRB_Config.Runes["Order"] = {};
		TRB_Config.Runes.Order["Blood"] = TRB_Config_Defaults.Runes.Order.Blood;
		TRB_Config.Runes.Order["Unholy"] = TRB_Config_Defaults.Runes.Order.Unholy;
		TRB_Config.Runes.Order["Frost"] = TRB_Config_Defaults.Runes.Order.Frost;
	end
--[[	
	if( not TRB_Config.Runes.Blood ) then
		TRB_Config.Runes.Order["Blood"] = TRB_Config_Defaults.Runes.Order.Blood;
	end
	
	if( not TRB_Config.Runes.Unholy ) then
		TRB_Config.Runes.Order["Unholy"] = TRB_Config_Defaults.Runes.Order.Unholy;
	end
	
	if( not TRB_Config.Runes.Frost ) then
		TRB_Config.Runes.Order["Frost"] = TRB_Config_Defaults.Runes.Order.Frost;
	end--]]
end

function TRB_Runes:OnDefault()
	self.Order = nil;

	-- Hide/Show DropDown boxes to update values
	self.DD_Bar1:Hide();
	self.DD_Bar1:Show();
	self.DD_Bar2:Hide();
	self.DD_Bar2:Show();
	self.DD_Bar3:Hide();
	self.DD_Bar3:Show();
end

function TRB_Runes:OnCancel()
	self.Order = nil;
	self:UpdateBarPositions();
end

function TRB_Runes:OnOkay()
--	if( not TRB_Config.Runes ) then self:LoadConfig(true); end
	if( not TRB_Config.Runes.Order ) then TRB_Config.Runes.Order = {}; end

	if( self.Order ) then
		TRB_Config.Runes.Order.Blood = self.Order.Blood;
		TRB_Config.Runes.Order.Unholy = self.Order.Unholy;
		TRB_Config.Runes.Order.Frost = self.Order.Frost;
		self.Order = nil;
		
		--self:Print("Blood => "..(TRB_Config.Runes.Order.Blood or "nil"));
		--self:Print("Unholy => "..(TRB_Config.Runes.Order.Unholy or "nil"));
		--self:Print("Frost => "..(TRB_Config.Runes.Order.Frost or "nil"));
	end
	
	-- Disable/Enable cooldown countdown text
	local status = self.CB_DisableText:GetChecked();
	if( status ) then
		TRB_Config.Runes.noText = nil;
	else
		TRB_Config.Runes.noText = true;
	end
	
	self:UpdateBarPositions();
end

function TRB_Runes:DD_Update(bar1, value1)
	value1 = DD_items[value1];	-- Get value as text
	
	if( not self.Order ) then
		self.Order = {};
		-- make it so we can lookup what rune a bar have
		for k,v in pairs(TRB_Config.Runes.Order) do
			self.Order[v] = k;
			self.Order[k] = v;
		end
	end


--	self:Print(bar1.." set to "..value1);
	

	-- 1) Find bar2 that value1 has
	local bar2 = self.Order[value1]; -- Get bar2;
	-- 2) Find value2 that bar1 has
	local value2 = self.Order[bar1]; -- Get value2
	
--	self:Print(bar2.." currently set to "..value1.." changed to "..value2);
	
	-- 3) Give bar2 value2
	UIDropDownMenu_SetSelectedValue(_G["TRB_Runes_"..bar2], value2);
	
	-- 4) Save changes
	self.Order[bar1] = value1;
	self.Order[bar2] = value2;
	self.Order[value1] = bar1;
	self.Order[value2] = bar2;
	
	self:UpdateBarPositions();	
end

function DD_Bar1OnClick(self)
	UIDropDownMenu_SetSelectedID(TRB_Runes.DD_Bar1, self:GetID())
	
	TRB_Runes:DD_Update("Bar1", self:GetID() );
end

function DD_Bar2OnClick(self)
	UIDropDownMenu_SetSelectedID(TRB_Runes.DD_Bar2, self:GetID())
	TRB_Runes:DD_Update("Bar2", self:GetID() );
end

function DD_Bar3OnClick(self)
	UIDropDownMenu_SetSelectedID(TRB_Runes.DD_Bar3, self:GetID())
	TRB_Runes:DD_Update("Bar3", self:GetID() );
end

function DropDownInit(self, level)
--	DEFAULT_CHAT_FRAME:AddMessage("INIT DD: "..self:GetName() );
	
	local info = UIDropDownMenu_CreateInfo()
	for k,v in pairs(DD_items) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = v
		if( self:GetName() == "TRB_Runes_Bar1" ) then
			info.func = DD_Bar1OnClick
		elseif( self:GetName() == "TRB_Runes_Bar2" ) then
			info.func = DD_Bar2OnClick
		else
			info.func = DD_Bar3OnClick
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function TRB_Runes:OnInitOptions(panel)

	local bar1 = CreateFrame("frame", "TRB_Runes_Bar1", panel, "UIDropDownMenuTemplate");
	bar1:ClearAllPoints();
	bar1:SetPoint("TOPLEFT", panel, "TOPLEFT", 20, -170);
	bar1:SetScript("OnShow", function(self) 
									local o = {};
									for k,v in pairs(TRB_Config.Runes.Order) do
										o["TRB_Runes_"..v] = k;
									end
									--DEFAULT_CHAT_FRAME:AddMessage( self:GetName().." Default "..self.o[self:GetName()]);
									UIDropDownMenu_SetSelectedValue(self, (o[self:GetName()] or "Blood"));
									UIDropDownMenu_SetText(self, (o[self:GetName()] or "Blood"));
								end );
	bar1:Show();
	self.DD_Bar1 = bar1
	
	UIDropDownMenu_Initialize(bar1, DropDownInit)
	UIDropDownMenu_SetWidth(bar1, 100);
	UIDropDownMenu_SetButtonWidth(bar1, 124)
	--UIDropDownMenu_SetSelectedValue(bar1, self.Order["Bar1"])
	UIDropDownMenu_JustifyText(bar1, "LEFT")

	local bar2 = CreateFrame("frame", "TRB_Runes_Bar2", panel, "UIDropDownMenuTemplate");
	bar2:ClearAllPoints();
	bar2:SetPoint("TOPLEFT", panel, "TOPLEFT", 20+140, -170);
	bar2:SetScript("OnShow", function(self) 
									local o = {};
									for k,v in pairs(TRB_Config.Runes.Order) do
										o["TRB_Runes_"..v] = k;
									end
									--DEFAULT_CHAT_FRAME:AddMessage( self:GetName().." Default "..o[self:GetName()]);
									UIDropDownMenu_SetSelectedValue(self, (o[self:GetName()] or "Unholy"));
									UIDropDownMenu_SetText(self, (o[self:GetName()] or "Unholy"));
								end );
	bar2:Show();
	self.DD_Bar2 = bar2
	
	UIDropDownMenu_Initialize(bar2, DropDownInit)
	UIDropDownMenu_SetWidth(bar2, 100);
	UIDropDownMenu_SetButtonWidth(bar2, 124)
	--UIDropDownMenu_SetSelectedValue(bar2, self.Order["Bar2"])
	UIDropDownMenu_JustifyText(bar2, "LEFT")
	
	local bar3 = CreateFrame("frame", "TRB_Runes_Bar3", panel, "UIDropDownMenuTemplate");
	bar3:ClearAllPoints();
	bar3:SetPoint("TOPLEFT", panel, "TOPLEFT", 20+280, -170);
	bar3:SetScript("OnShow", function(self) 
									local o = {};
									for k,v in pairs(TRB_Config.Runes.Order) do
										o["TRB_Runes_"..v] = k;
									end
									--DEFAULT_CHAT_FRAME:AddMessage( self:GetName().." Default "..self.o[self:GetName()]);
									UIDropDownMenu_SetSelectedValue(self, (o[self:GetName()] or "Frost"));
									UIDropDownMenu_SetText(self, (o[self:GetName()] or "Frost"));
								end );
	bar3:Show();
	self.DD_Bar3 = bar3
	
	UIDropDownMenu_Initialize(bar3, DropDownInit)
	UIDropDownMenu_SetWidth(bar3, 100);
	UIDropDownMenu_SetButtonWidth(bar3, 124)
	--UIDropDownMenu_SetSelectedValue(bar3, self.Order["Bar3"])
	UIDropDownMenu_JustifyText(bar3, "LEFT")
	
	--
	-- Disable Rune cooldown counter text
	--
	local cb = CreateFrame("CheckButton", "TRB_Runes_DisableText", panel, "InterfaceOptionsCheckButtonTemplate");
	cb:SetPoint("TOPLEFT", panel, "TOPLEFT", 20, -220);
	cb.text = _G[cb:GetName().."Text"];
	cb.text:SetText("Enable "..self.name.." cooldown counter text");
	local v = true;
	if( TRB_Config.Runes.noText and TRB_Config.Runes.noText == true ) then
		v = false;
	end
	cb:SetChecked( v );
	self.CB_DisableText = cb;
end
