if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
   return
end

------------------------------------------------------------------------
local BG_Tex = "Interface\\AddOns\\ThreeRuneBars\\runicpower.tga";

TRB_RunicPower = TRB_Module:create("RunicPower");

function TRB_RunicPower:OnDisable()
	self.frame:SetScript("OnEvent", nil);
	self.frame:SetScript("OnUpdate", nil);
end

function TRB_RunicPower:getDefault(val)
	if( val == "Position" ) then
		return { "CENTER", nil, "CENTER", 160, -25 };
	end
	return nil;
end

function TRB_RunicPower:OnEnable()
	if( not self.frame ) then
		local f = CreateFrame("frame", nil, UIParent);
	
		-- Set Position and size
		f:ClearAllPoints();
		f:SetWidth(310);
		f:SetHeight(12);
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
		f:SetFrameStrata("HIGH"); -- Set to HIGH framestrata to be visible ontop of Blizzards "Power Aura" thing
		f:Show();
		f.owner = self;
		
		-- Background
		local bg = f:CreateTexture(nil, "BACKGROUND");
		bg:SetWidth(512);
		bg:SetHeight(512);
		bg:SetPoint("CENTER", f, "CENTER", 0, 0);
		bg:SetTexture(BG_Tex);
		f.bg = bg;
		
		self.frame = f;
		
		self:CreateMoveFrame();
	end

	if( not self.Bar ) then
	
		-- Runic Power
		local rp = self:CreateBar("TRB_RunicPower", self.frame);
		rp:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 2, -2);
		rp:SetWidth(306);
		rp:SetValue( UnitPower("player") );
		rp:SetMinMaxValues( 0, UnitPowerMax("player", 6) );
		rp:SetStatusBarColor( unpack(TRB_Config[self.name].Colors) );
		
		-- Text for Runic Power
		rp.text:SetText(UnitPower("player") or 0);
		self.Bar = rp;

	end

	-- Runic Power
	self.frame:RegisterEvent("UNIT_POWER");
	self.frame:RegisterEvent("UNIT_MAXPOWER");

	self.frame:SetScript("OnEvent", function(frame, event, ...) frame.owner[event](frame.owner, ...); end );
	self.frame:SetScript("OnUpdate", function(frame, elapsed) frame.owner:OnUpdate(elapsed); end );
	
end

function TRB_RunicPower:getDefault(val)
	if( val == "Position" ) then
		return TRB_Config_Defaults[self.name].Position or { "CENTER", nil, "CENTER", 0, -150 };
	elseif( val == "Color" ) then
		return TRB_Config_Defaults[self.name].Colors or { [1] = 0.2, [2] = 0.7, [3] = 1,   [4] = 1 };
	end
	return nil;
end

-- Runic Power EVENTS
function TRB_RunicPower:UNIT_POWER(unit, power)
	if( unit == "player" ) then
		local rp = UnitPower("player")
		--DEFAULT_CHAT_FRAME:AddMessage("RP: "..rp);
		self.Bar:SetMinMaxValues( 0, UnitPowerMax("player", 6) );
		self.Bar:SetValue(rp);
		self.Bar.text:SetText(rp);
		--DEFAULT_CHAT_FRAME:AddMessage("bar: "..Bars[7]:GetValue());
	end
end

function TRB_RunicPower:UNIT_MAXPOWER(unit, power)
	self.Bar:SetMinMaxValues( 0, UnitPowerMax("player", 6) );
end

-- OnUpdate
function TRB_RunicPower:OnUpdate(elapsed)
	self.last = (self.last or 0) + elapsed;
	
	if( self.last > 2.0 ) then
	
		self:UNIT_POWER("player", "RUNIC_POWER");
		
		self.last = 0;
	end
end

-- Register Disease module
ThreeRuneBars:RegisterModule(TRB_RunicPower.name, TRB_RunicPower);

